# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.InternetTracking do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :ActorKeyNumeric,
    :ActorLatitude,
    :ActorLongitude,
    :ColorDepth,
    :EventKeyNumeric,
    :ObjectKeyNumeric,
    :ScreenHeight,
    :ScreenWidth,
    :TimeZoneOffset,
    :ActorCity,
    :ActorEmail,
    :ActorID,
    :ActorIP,
    :ActorKey,
    :ActorOriginatingSystemID,
    :ActorOriginatingSystemName,
    :ActorPhone,
    :ActorPhoneExt,
    :ActorPostalCode,
    :ActorPostalCodePlus4,
    :ActorRegion,
    :ActorSourceSystemID,
    :ActorSourceSystemName,
    :EventDescription,
    :EventKey,
    :EventLabel,
    :EventOriginatingSystemID,
    :EventOriginatingSystemName,
    :EventSourceSystemID,
    :EventSourceSystemName,
    :ObjectID,
    :ObjectKey,
    :ObjectOriginatingSystemID,
    :ObjectOriginatingSystemName,
    :ObjectSourceSystemID,
    :ObjectSourceSystemName,
    :ObjectURL,
    :OriginatingSystemActorKey,
    :OriginatingSystemEventKey,
    :OriginatingSystemObjectKey,
    :ReferringURL,
    :SessionID,
    :SourceSystemActorKey,
    :SourceSystemEventKey,
    :SourceSystemObjectKey,
    :UserAgent,
    :ActorStateOrProvince,
    :ActorType,
    :DeviceType,
    :EventTarget,
    :EventType,
    :ObjectIdType,
    :ObjectType,
    :EventTimestamp,
    :ActorOriginatingSystem,
    :ActorSourceSystem,
    :EventOriginatingSystem,
    :EventSourceSystem,
    :ObjectOriginatingSystem,
    :ObjectSourceSystem
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :ActorKeyNumeric => float() | nil,
    :ActorLatitude => float() | nil,
    :ActorLongitude => float() | nil,
    :ColorDepth => float() | nil,
    :EventKeyNumeric => float() | nil,
    :ObjectKeyNumeric => float() | nil,
    :ScreenHeight => float() | nil,
    :ScreenWidth => float() | nil,
    :TimeZoneOffset => float() | nil,
    :ActorCity => String.t | nil,
    :ActorEmail => String.t | nil,
    :ActorID => String.t | nil,
    :ActorIP => String.t | nil,
    :ActorKey => String.t | nil,
    :ActorOriginatingSystemID => float() | nil,
    :ActorOriginatingSystemName => String.t | nil,
    :ActorPhone => String.t | nil,
    :ActorPhoneExt => String.t | nil,
    :ActorPostalCode => String.t | nil,
    :ActorPostalCodePlus4 => String.t | nil,
    :ActorRegion => String.t | nil,
    :ActorSourceSystemID => float() | nil,
    :ActorSourceSystemName => String.t | nil,
    :EventDescription => String.t | nil,
    :EventKey => String.t | nil,
    :EventLabel => String.t | nil,
    :EventOriginatingSystemID => float() | nil,
    :EventOriginatingSystemName => String.t | nil,
    :EventSourceSystemID => float() | nil,
    :EventSourceSystemName => String.t | nil,
    :ObjectID => String.t | nil,
    :ObjectKey => String.t | nil,
    :ObjectOriginatingSystemID => float() | nil,
    :ObjectOriginatingSystemName => String.t | nil,
    :ObjectSourceSystemID => float() | nil,
    :ObjectSourceSystemName => String.t | nil,
    :ObjectURL => String.t | nil,
    :OriginatingSystemActorKey => String.t | nil,
    :OriginatingSystemEventKey => String.t | nil,
    :OriginatingSystemObjectKey => String.t | nil,
    :ReferringURL => String.t | nil,
    :SessionID => String.t | nil,
    :SourceSystemActorKey => String.t | nil,
    :SourceSystemEventKey => String.t | nil,
    :SourceSystemObjectKey => String.t | nil,
    :UserAgent => String.t | nil,
    :ActorStateOrProvince => String.t | nil,
    :ActorType => String.t | nil,
    :DeviceType => String.t | nil,
    :EventTarget => String.t | nil,
    :EventType => String.t | nil,
    :ObjectIdType => String.t | nil,
    :ObjectType => String.t | nil,
    :EventTimestamp => Date.t | nil,
    :ActorOriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :ActorSourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :EventOriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :EventSourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :ObjectOriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :ObjectSourceSystem => FoyerAPI.Model.Ouid.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.InternetTracking do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:EventTimestamp, :date, nil, options)
    |> deserialize(:ActorOriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ActorSourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:EventOriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:EventSourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ObjectOriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ObjectSourceSystem, :struct, FoyerAPI.Model.Ouid, options)
  end
end

